<?php

class WDD_replace extends plxPlugin {

	private $rules;
	private $files;
	private $mypath;

	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# limite l'accès à l'écran d'administration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->addHook('WDD_replace_list', 'WDD_replace_list');
		$this->addHook('ThemeEndBody', 'ThemeEndBody');
		$this->addHook('ThemeEndHead', 'ThemeEndHead');
		$this->addHook('plxMotorParseArticle', 'plxMotorParseArticle');
		$this->addHook('AdminArticlePreview', 'AdminArticlePreview');
		$this->addHook('plxMotorParseCommentaire', 'plxMotorParseCommentaire');
		$this->addHook('AdminArticleTop', 'AdminArticleTop');
		$this->addHook('AdminCommentNewTop', 'AdminArticleTop');
		$this->addHook('AdminArticleFoot', 'AdminArticleFoot');
		$this->addHook('AdminCommentNew', 'AdminArticleFoot');
		$this->addHook('WDD_replace_js', 'WDD_replace_js');
		$myfolder=PLX_PLUGINS.'WDD_replace/img/';
		$emotes['normal']=glob($myfolder.'normal/*');
		$emotes['medium']=glob($myfolder.'medium/*');
		$emotes['big']   =glob($myfolder.'big/*');
		$emotes['xbig']  =glob($myfolder.'xbig/*');
		foreach($emotes as $size=>$files){
			foreach($files as $file){
				$base=pathinfo($file,PATHINFO_FILENAME);
				if ($base=='index'){continue;}
				$code='*'.$base.'*';
				$img='<img class="smile '.$size.'" src="'.$file.'"/>';
				$rules[$code]=$img;
				$paths[$code]=$file;
			}			
		}
		include(PLX_PLUGINS.'WDD_replace/rules.php'); 
		$rules=array_merge($rules,$other_rules);
		$this->rules = $rules;		
		$this->files = $paths;		
		$this->mypath= PLX_PLUGINS.'WDD_replace/';		
		
	}
	
	# HOOKS
	
	# "WDD_replace"
	public function WDD_replace($contenu='',$only_path=false) {
		require_once($this->mypath.'auto_thumb.php');
		global $plxAdmin;
		$plxMotor=plxMotor::getInstance();
		if (isset($plxMotor)){$root=$plxMotor->aConf['racine'];}
		else{$root=$plxAdmin->aConf['racine'];}
		if (!$only_path){ 
			$contenu= str_replace(array_keys($this->rules),array_values($this->rules),$contenu);
			
		}else{
			$contenu= str_replace(array_keys($this->files),array_values($this->files),$contenu);
			$contenu= str_replace('./plugins/',$root.'plugins/',$contenu);
		}

		if (preg_match_all('#(<galerie .*?>)#', $contenu, $galeries)){
			// parse les commandes des galeries et récupère src et attr
			foreach ($galeries[1] as $galerie){
				// extraction des attr
				preg_match('#src="([^"]+)"#',$galerie,$attr);
				$src=$attr[1];
				if (preg_match('#title="([^\"]+)"#',$galerie,$attr)){$title=$attr[1];}else{$title=null;}
				if (preg_match('#width="([0-9]+)"#',$galerie,$attr)){$width=$attr[1];}else{$width=null;}
				if (preg_match('#height="([0-9]+)"#',$galerie,$attr)){$height=$attr[1];}else{$height=null;}
				if (stripos($galerie,"crop=")!==false){$crop=true;}else{$crop=false;}
				if (stripos($galerie,"infos=")!==false){$infos=true;}else{$infos=false;}
				if (stripos($galerie,"style=")!==false){$style=true;}else{$style=false;}
				//création du code de la galerie 
				$code=auto_galerie($src,$title,$width,$height,$crop,$infos,$style);
				$contenu=str_replace($galerie,$code,$contenu);
			}

		}


		return $contenu; 
	}

	# "plxMotorParseArticle"
	public function plxMotorParseArticle() {
		echo  '<?php 
		if (empty($_GET["a"])){
			$art["content"]=$this->plxPlugins->aPlugins["WDD_replace"]->WDD_replace($art["content"]);
			$art["chapo"]  =$this->plxPlugins->aPlugins["WDD_replace"]->WDD_replace($art["chapo"]);
		}

		?>';
		
	}
	# "AdminArticlePreview"
	public function AdminArticlePreview() {
		echo  '<?php 		
			$art["content"]=str_replace(\'<img class="smile" src="../../\',\'<img class="smile" src="\',$plxAdmin->plxPlugins->aPlugins["WDD_replace"]->WDD_replace($art["content"]));
			$art["chapo"]  =str_replace(\'<img class="smile" src="../../\',\'<img class="smile" src="\',$plxAdmin->plxPlugins->aPlugins["WDD_replace"]->WDD_replace($art["chapo"]));
			?>';
		
	}
	# "AdminArticleTop"
	public function AdminArticleTop() {
		echo '<script src="'.$this->mypath.'VanillaJS.js"></script>';	
	}
	# "AdminArticleFoot"
	public function AdminArticleFoot() {
		$plxMotor=plxMotor::getinstance();
		echo  '<div class="emotes_list">';
		$this->WDD_replace_list('active_emotes');
		echo '</div>';
		echo '<script src="'.$plxMotor->urlRewrite($this->mypath).'active_emotes.js"></script>';	
	}
	# "plxMotorParseCommentaire"
	public function plxMotorParseCommentaire() {
		echo  '<?php 
			$com["content"]=$this->plxPlugins->aPlugins["WDD_replace"]->WDD_replace($com["content"]);
		?>';
		
	}

	#
	# "WDD_replace_list"
	# affiche ou renvoie la liste des règles ou la liste des remplacements
	# $param='list' => echo la liste des clés de $rule séparées par un espace
	# $param='emotes' => echo les émoticones de remplacement
	# $param='active_emotes' => echo les émoticones de remplacement avec leur attribut add (pour la fonction js d'ajout par clic)
	public function WDD_replace_list($param="emotes"){// active_emotes, emotes, list, array
		$r="\n";$e="";$done=array();
		if ($param=='array'){return $this->rules;}		
		foreach($this->files as $rul=>$file){

			if (!empty($done[$file])){continue;}
			$repl=$this->rules[$rul];
			if ($rul=='[spoiler]'||$rul=='[/spoiler]'){continue;}		
			if ($param=='list'){ 
				echo $rul." ";
			}else if ($param=='emotes'){
				echo $repl.' ';
			}else if ($param=='active_emotes'){
				echo str_replace('img ','img add="'.$rul.'" ',$repl).$r;
			}
			$done[$file]=true;
		}
		
		echo '<br/><a class="addspoiler" add="[spoiler]...[/spoiler]" title="zone de spoiler caché">spoiler</a>';
		if (defined('PLX_ADMIN')){
			echo '	<script>
						list=first("#article .emotes_list");
						if (list){
							listcontent=list.innerHTML;
							after("#id_chapo","<div class=\"emotes_list\" target=\"#id_chapo\">"+listcontent+"</div>");
							after("#id_content","<div class=\"emotes_list\" target=\"#id_content\">"+listcontent+"</div>");
							remove(list);
						}
					</script>';
		}
	}

	public function WDD_replace_js(){
		$plxMotor=plxMotor::getinstance();
		echo '<script src="'.$plxMotor->urlRewrite($this->mypath).'VanillaJS.js"></script>';			
		echo '<script src="'.$plxMotor->urlRewrite($this->mypath).'active_emotes.js"></script>';	
	}

	public function ThemeEndBody() {
		$this->WDD_replace_js();
	}
	public function ThemeEndHead() {
		$plxMotor=plxMotor::getinstance();
		echo '<link rel="stylesheet" href="'.$plxMotor->urlRewrite($this->mypath).'style.css">';
	}
}
?>
